% "Introduction to Pattern Recognition: A MATLAB Approach"
% S. Theodoridis, A. Pikrakis, K. Koutroumbas, D. Cavouras
%
% CHAPTER 2: m-files
%
%   base_clas_coord       - Implements a specific "weak" classifier.
%   base_clas_coord_out   - Computes the output of the weak classifier
%                           implemented by the base_clas_coord function.
%   boost_clas_coord      - Generation of a "strong" classifier, using the 
%                           Adaboost algorithm, that utilizes weak classifiers 
%                           generated by the base_clas_coord function.
%   boost_clas_coord_out  - Computes the output of a "strong" classifier as
%                           a weighted sum of the outputs of weak classifiers.
%   CalcKernel            - Computes the value of a Kernel function between two points.
%   kernel_perce          - Implements the kernel perceptron algorithm.
%   NN_evaluation         - Returns the classification error of a neural network based on a data set.
%   NN_training           - Returns a trained multilayer perceptron.
%   perce                 - Realizes the perceptron learning rule, in a batch mode.
%   perce_online          - Realizes the online perceptron learning rule.
%   plot_kernel_perce_reg - Plots the decision boundary that is generated by the kernel perceptron
%                           algorithm.
%   plot_NN_reg           - Plots the decision boundary that is formed by a neural network.
%   SMO2                  - Generates a SVM classifier using either Platt's algorithm or one 
%                           of its two modifications proposed by Keerthi.
%   SSErr                 - Generated the linear classifier based on the sum of error squares criterion.
%   svcplot_book          - Support Vector Machine plotting utility.
%                           It plots the decision regions, the decision
%                           surfaces and the margin obtained by a SVM classifier.
